import Box from '@mui/material/Box';
import Modal from '@mui/material/Modal';
import { useEffect, useState } from 'react';


export default function ModalTask({modal, handleClose, children}) {

  const [windowDimenion, detectHW] = useState({
    winWidth: window.innerWidth,
    winHeight: window.innerHeight,
  })

  const detectSize = () => {
    detectHW({
      winWidth: window.innerWidth,
      winHeight: window.innerHeight,
    })
  }

  useEffect(() => {
    window.addEventListener('resize', detectSize)

    return () => {
      window.removeEventListener('resize', detectSize)
    }
  }, [windowDimenion])

  const getYCordinatesToModal = () => {
    if (windowDimenion.winHeight > modal.yClickСordinates + 350) {
      return modal.yClickСordinates - modal.yDiv - modal.yDivClick 
    } else {
      return modal.yClickСordinates - modal.yDiv - modal.yDivClick - ((modal.yClickСordinates + 350) - windowDimenion.winHeight) - 10
    }
  }
  const getXCordinatesToModal = () => {
    if (windowDimenion.winWidth > modal.xClickСordinates + modal.xDiv + 250 + modal.xDivClick) {
      return modal.xClickСordinates + modal.xDiv - modal.xDivClick + 10
    } else {
      return modal.xClickСordinates - modal.xDiv - ((modal.xClickСordinates + 250) - windowDimenion.winWidth) - 120
    }
  }
  const style = {
    position: 'absolute',
    top: getYCordinatesToModal(),
    left: getXCordinatesToModal(),
    width: 250,
    height: 350,
    bgcolor: 'background.paper',
    border: '2px solid #000',
    boxShadow: 24,
    p: 4,
  };
  return (
    <>
      <Modal
        open={modal.open}
        onClose={handleClose}
        aria-labelledby="modal-modal-title"
        aria-describedby="modal-modal-description"
        BackdropProps={{ style: { backgroundColor: 'rgba(255,255,255, 0)' } }}
      >
        <Box sx={style}>
          {children}
        </Box>
      </Modal>
    </>
  );
}